// Tools Library
//
// Copyright (C) 2004  Navel Ltd.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Contact information:
//  Mailing address:
//    Marios Hadjieleftheriou
//    University of California, Riverside
//    Department of Computer Science
//    Surge Building, Room 310
//    Riverside, CA 92521
//
//  Email:
//    lifeifei@cs.bu.edu, mhadji@gmail.com

#include <Tools.h>

using namespace std;

int main(int argc, char** argv)
{
	Tools::Random r;

	for (unsigned long cIndex = 0; cIndex < 10; cIndex++)
	{
		cout << r.nextZipfDouble(10.0, 50.0, Tools::LVL_LOW) << endl;
	}

	cout << endl;

	for (unsigned long cIndex = 0; cIndex < 10; cIndex++)
	{
		cout << r.nextUniformDouble() << endl;
	}

	cout << endl;

	for (unsigned long cIndex = 0; cIndex < 10; cIndex++)
	{
		cout << r.nextUniformDouble(10.0, 50.0) << endl;
	}

	std::set<int> s;
	for (unsigned long i = 0; i < 4000000; i++)
	{
		s.insert(r.nextUniformLong(0L, 2000000L));
	}
	
	std::cerr << std::endl << s.size() << " distinct random numbers produced" << std::endl;

	return 0;
}
